#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf evilwm_0.99.17.orig.tar.gz
    cd evilwm-0.99.17.orig
    bunzip2 -c ../evilwm-0.99.17-dietpc-patch.bz2 | patch -p1 -b
    ed -s Makefile >/dev/null <<EOF
/^CFLAGS  +=/d
i
CFLAGS  += \$(INCLUDES) \$(DEFINES) -Wall
.
w
q
EOF
    make
    strip -R .note -R .comment evilwm
    mkdir -p ../evilwm/bin
    cp evilwm ../evilwm/bin/
    cd ..
    rm -rf evilwm-0.99.17.orig
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
